VERSION 5.00
Begin VB.Form MemoryBanksForm 
   Caption         =   "Memory Banks Read/Write"
   ClientHeight    =   4575
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   7725
   LinkTopic       =   "Form1"
   ScaleHeight     =   4575
   ScaleWidth      =   7725
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton WriteMemoryBanksButton 
      Caption         =   "&Write ""Testing 123"" to Each Main Memory Bank Page"
      Height          =   1095
      Left            =   5760
      TabIndex        =   2
      Top             =   2280
      Width           =   1815
   End
   Begin VB.CommandButton ReadMemBanksButton 
      Caption         =   "&Read Memory Banks"
      Height          =   615
      Left            =   5760
      TabIndex        =   1
      Top             =   1200
      Width           =   1815
   End
   Begin VB.TextBox TextForMemBanks 
      BeginProperty Font 
         Name            =   "Courier New"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   3495
      Left            =   240
      MultiLine       =   -1  'True
      ScrollBars      =   2  'Vertical
      TabIndex        =   0
      Top             =   240
      Width           =   5295
   End
End
Attribute VB_Name = "MemoryBanksForm"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'-------------------------------------------------------------------------
'Copyright (C) 2004 Dallas Semiconductor MAXIM Corporation, All Rights Reserved.
'
'Permission is hereby granted, free of charge, to any person obtaining a
'copy of this software and associated documentation files (the "Software"),
'to deal in the Software without restriction, including without limitation
'the rights to use, copy, modify, merge, publish, distribute, sublicense,
'and/or sell copies of the Software, and to permit persons to whom the
'Software is furnished to do so, subject to the following conditions:
'
'The above copyright notice and this permission notice shall be included
'in all copies or substantial portions of the Software.
'
'THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
'OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
'MERCHANTABILITY,  FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
'IN NO EVENT SHALL DALLAS SEMICONDUCTOR BE LIABLE FOR ANY CLAIM, DAMAGES
'OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,
'ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
'OTHER DEALINGS IN THE SOFTWARE.
'
'Except as contained in this notice, the name of Dallas Semiconductor
'shall not be used except as stated in the Dallas Semiconductor
'Branding Policy.
'

Private Sub Form_Load()

On Error GoTo ErrorTrap

' make control line-feed string
CRLF = Chr(13) & Chr(10)
   
' get the 1-Wire access provider
Set access = New owapi.OneWireAccessProvider

' get the default adapter
Set adapter = access.getDefaultAdapter

' print that we got an adapter
TextForMemBanks.Text = TextForMemBanks.Text & CRLF & "Adapter: " & adapter.getAdapterName & " Port: " & adapter.getPortName & CRLF & CRLF

Exit Sub

ErrorTrap:
    lastError = Err.Description
    TextForMemBanks.Text = TextForMemBanks.Text & CRLF & lastError & CRLF
    
End Sub


Private Sub ReadMemBanksButton_Click()
 On Error GoTo ErrorTrap
' Clicking this button retrieves all 1-Wire parts found on a 1-Wire
' network and lists their addresses and Memory Banks (if any).

Dim owd
Dim mb
Dim OneWireAddress
Dim state
Dim memoryBanksFound
Dim count As Integer
' DS1977's memory is too large to display in text box, so we will create a file '
Dim fso         'a FileSystemObject'
Dim newfile     'newfile is the MemContents.txt file'
Dim txtstream   'newfile gets turned into a TextStream'


' get exclusive use of 1-Wire network
adapter.beginExclusive (True)

' clear any previous search restrictions
adapter.setSearchAllDevices
adapter.targetAllFamilies
adapter.setSpeed (adapter.SPEED_REGULAR)

' enumerate through all the 1-Wire devices found (with Java-style enumeration)
Set owd_enum = adapter.getAllDeviceContainers
TextForMemBanks.Text = "1-Wire List:" & CRLF
TextForMemBanks.Text = TextForMemBanks.Text & "==========================" & CRLF
memoryBanksFound = 0
While owd_enum.hasMoreElements
   ' retrieve OneWireContainer
   Set owd = owd_enum.nextElement
   ' make OneWireContainer into specific OneWireContainer (i.e., OneWireContainer23)
   Set owd = owd.getMostSpecificComponent
   ' Set owd to max possible speed with available adapter, allow fall back
   If (adapter.canOverdrive() And owd.getMaxSpeed() = adapter.SPEED_OVERDRIVE) Then
       owd.setSpeed owd.getMaxSpeed(), True
   End If
   ' retrieve OneWireAddress
   TextForMemBanks.Text = TextForMemBanks.Text & CRLF ' adds a new blank line
   TextForMemBanks.Text = TextForMemBanks.Text & "Address = " & owd.getAddressAsString & CRLF
   ' check for existence of DS1977, then create a file to eventually dump contents'
   If owd.getName = "DS1977" Then
      ' Write out to textbox the DS1977 warning
      TextForMemBanks.Text = TextForMemBanks.Text & " Memory Contents too large to display here. " & CRLF
      TextForMemBanks.Text = TextForMemBanks.Text & " Writing Contents to file:  MemContents.txt." & CRLF
      ' Create a file (if necessary) for DS1977's memory read '
      Set fso = CreateObject("Scripting.FileSystemObject")
      If fso.FileExists("MemContents.txt") = False Then
         fso.CreateTextFile ("MemContents.txt")
      End If
      Set newfile = fso.GetFile("MemContents.txt")
      ' Open textfile and write header info
      Set txtfile = newfile.OpenAsTextStream(8)
      txtfile.WriteBlankLines (2)
      txtfile.WriteLine ("Address: " & owd.getAddressAsString & "  1-Wire Device: " & owd.getName)
      txtfile.Close
   End If

   ' check to see if 1-Wire device supports Memory Banks, if so get address.
   Set mb_enum = owd.getMemoryBanks
   While mb_enum.hasMoreElements
      ' retrieve MemoryBanks
      memoryBanksFound = 1
      Set mb = mb_enum.nextElement
      Set mb = mb.getMostSpecificComponent
      If owd.getName = "DS1977" Then
         ' Open textfile
         Set txtfile = newfile.OpenAsTextStream(8)
         txtfile.WriteLine (" Memory Bank:  " & mb.getBankDescription)
         txtfile.Close
      Else
         TextForMemBanks.Text = TextForMemBanks.Text & " Memory Bank:  " & (mb.getBankDescription) & CRLF
      End If
      ' Now, let's read out the MemoryBanks'
      Set readBuf = New ByteArray
      readBuf.setSize (mb.getPageLength)
      Set extraInfo = New ByteArray
      extraInfo.setSize (mb.getExtraInfoLength)
      Dim isfirst As Boolean
      Dim I As Integer
      isfirst = False
      ' loop to read all of the pages
      For I = 0 To mb.getNumberPages - 1
         If mb.haveExtraInfo Then
             mb.readPage I, isfirst, readBuf, 0, extraInfo
         Else
             mb.readPage I, isfirst, readBuf, 0
         End If
         pageLength = mb.getPageLength
         If pageLength > 32 Then
            quarter_len = pageLength / 4
            ' Open textfile for DS1977 '
            Set txtfile = newfile.OpenAsTextStream(8)
            txtfile.WriteLine (" Page " + Format(I, "000") + ": " + ToHexStr(readBuf, 0, quarter_len))
            txtfile.WriteLine ("           " + ToHexStr(readBuf, quarter_len, quarter_len))
            txtfile.WriteLine ("           " + ToHexStr(readBuf, quarter_len * 2, quarter_len))
            txtfile.WriteLine ("           " + ToHexStr(readBuf, quarter_len * 3, quarter_len))
            txtfile.Close
         End If
         If (pageLength <= 32) And (pageLength > 16) Then
            half_len = pageLength / 2
            TextForMemBanks.Text = TextForMemBanks.Text & " Page " + Format(I, "000") + ": " + ToHexStr(readBuf, 0, half_len) & CRLF
            TextForMemBanks.Text = TextForMemBanks.Text & "           " + ToHexStr(readBuf, half_len, pageLength - half_len) & CRLF
         End If
         If (pageLength <= 16) And (pageLength > 8) Then
            TextForMemBanks.Text = TextForMemBanks.Text & " Page " + Format(I, "000") + ": " + ToHexStr(readBuf, 0, pageLength) & CRLF
         End If
         If mb.haveExtraInfo Then  ' check for existence of Extra Info'
            If owd.getName = "DS1977" Then  ' check for DS1977 for printing to a file'
               ' Open textfile
               Set txtfile = newfile.OpenAsTextStream(8)
               txtfile.WriteLine ("           Extra: " + ToHexStr(extraInfo, 0, mb.getExtraInfoLength))
               txtfile.Close
            Else  ' If not DS1977, just print to screen'
               TextForMemBanks.Text = TextForMemBanks.Text & "           Extra: " + ToHexStr(extraInfo, 0, mb.getExtraInfoLength) & CRLF
            End If
         End If
         isfirst = True
      Next I
   Wend ' End Memory Bank enumeration loop
Wend ' End OneWireContainer enumeration loop

' show "No Memory Banks Found" message
If (memoryBanksFound = 0) Then
   TextForMemBanks.Text = TextForMemBanks.Text & CRLF & "No 1-Wire devices with Memory Banks found!" & CRLF
Else
   TextForMemBanks.Text = TextForMemBanks.Text & CRLF & "Finished Reading..." & CRLF
End If

' end exclusive use of adapter
adapter.endExclusive

TextForMemBanks.Text = TextForMemBanks.Text & CRLF & CRLF
TextForMemBanks.SelStart = Len(TextForMemBanks.Text) ' make textbox autoscroll down

Exit Sub

ErrorTrap:
    lastError = Err.Description
    TextForMemBanks.Text = TextForMemBanks.Text & CRLF & lastError & CRLF
    adapter.endExclusive

End Sub

Private Sub WriteMemoryBanksButton_Click()
 On Error GoTo ErrorTrap
' Clicking this button retrieves all 1-Wire parts found on a 1-Wire
' network and lists their addresses and Memory Banks (if any).

Dim owd
Dim mb
Dim OneWireAddress
Dim state
Dim memoryBanksFound
Dim count As Integer
Dim I As Integer
Dim adapterMaxSpeed As Integer

' write out message that we are attempting to write to the part
TextForMemBanks.Text = TextForMemBanks.Text & CRLF & "Attempting to write ''Testing 123'' to memory pages" & CRLF & CRLF
' get exclusive use of 1-Wire network
adapter.beginExclusive (True)

' clear any previous search restrictions
adapter.setSearchAllDevices
adapter.targetAllFamilies
adapter.setSpeed (adapter.SPEED_REGULAR)

' enumerate through all the 1-Wire devices found (with Java-style enumeration)
Set owd_enum = adapter.getAllDeviceContainers
TextForMemBanks.Text = TextForMemBanks.Text & "1-Wire List:" & CRLF
TextForMemBanks.Text = TextForMemBanks.Text & "========================" & CRLF
memoryBanksFound = 0
While owd_enum.hasMoreElements
   ' retrieve OneWireContainer
   Set owd = owd_enum.nextElement
   ' make OneWireContainer into specific OneWireContainer (i.e., OneWireContainer23)
   Set owd = owd.getMostSpecificComponent
   ' Set owd to max possible speed with available adapter, allow fall back
   If (adapter.canOverdrive() And owd.getMaxSpeed() = adapter.SPEED_OVERDRIVE) Then
      owd.setSpeed owd.getMaxSpeed(), True
   End If
   ' retrieve OneWireAddress
   TextForMemBanks = TextForMemBanks & "Address = " & owd.getAddressAsString & CRLF
   ' check to see if 1-Wire device supports Memory Banks, if so get address.
   Set mb_enum = owd.getMemoryBanks
   While mb_enum.hasMoreElements
      ' retrieve MemoryBanks
      memoryBanksFound = 1
      Set mb = mb_enum.nextElement
      Set mb = mb.getMostSpecificComponent
      TextForMemBanks.Text = TextForMemBanks.Text & " Memory Bank:  " & (mb.getBankDescription) & CRLF
      If (mb.getBankDescription = "Main Memory" Or mb.getBankDescription = "Data Memory") Then
         TextForMemBanks.Text = TextForMemBanks.Text & " Found the Main Memory Bank, writing..."
         ' Now, let's write to the Main Memory Memory Bank, page by page'
         Set writeBuf = New ByteArray
         ' For more info on ByteArray, please see
         ' the OWCOM Overview here:
         ' ftp://ftp.dalsemi.com/pub/auto_id/softdev/owdocs/Docs/OWCom/OWCOM_Overview.html
         
         writeBuf.setSize (11) ' set size to "testing 123"
         writeBuf.setAt 0, Asc("T")
         writeBuf.setAt 1, Asc("E")
         writeBuf.setAt 2, Asc("S")
         writeBuf.setAt 3, Asc("T")
         writeBuf.setAt 4, Asc("I")
         writeBuf.setAt 5, Asc("N")
         writeBuf.setAt 6, Asc("G")
         writeBuf.setAt 7, Asc(" ")
         writeBuf.setAt 8, Asc("1")
         writeBuf.setAt 9, Asc("2")
         writeBuf.setAt 10, Asc("3")
         
         Dim isfirst As Boolean
         isfirst = False
         ' loop to write all of the pages
         For I = 0 To mb.getNumberPages - 1
            'Call mb.write((I * mb.getPageLength), writeBuf, 0, 11)
            mb.writePagePacket I, writeBuf, 0, 11
            isfirst = True
         Next I
      End If
   Wend ' End Memory Bank enumeration loop
Wend ' End OneWireContainer enumeration loop

' show "No Memory Banks Found" message
If (memoryBanksFound = 0) Then
   TextForMemBanks.Text = TextForMemBanks.Text & CRLF & "No 1-Wire devices with Memory Banks found!" & CRLF
Else
   TextForMemBanks.Text = TextForMemBanks.Text & CRLF & "Finished Writing..." & CRLF
End If

' end exclusive use of adapter
adapter.endExclusive

TextForMemBanks.Text = TextForMemBanks.Text & CRLF & CRLF
TextForMemBanks.SelStart = Len(TextForMemBanks.Text) ' make textbox autoscroll down

Exit Sub

ErrorTrap:
    lastError = Err.Description
    TextForMemBanks.Text = TextForMemBanks.Text & CRLF & lastError & CRLF
    adapter.endExclusive
End Sub
